(define-module (ui net-domain ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator effect)
    :export (on-load))

(define *resolver* "unknown")
(define *access* "unknown")
(define *ldap* "unknown")
(define *kdc* "unknown")
(define *smb* "unknown")
(define *dhcpd* "unknown")
(define *master* "off")
(define *ad-dns* "")
(define *ad-service* "")
(define *ad-domain* "")
(define *ad-realm* "")
(define *ad-dc-name* "")
(define *ad-ldap-server* "")
(define *ad-kdc-server* "")
(define *altdomain-avail* "#t")
(define *ad-avail* "#t")
(define *domain-type* "")

(define (ui-read)
  (catch/message
    (lambda()
      (form-update-value-list '("domain")
			      (woo-read-first "/net-domain"))
      (let* ((data (woo-read"/net-domain" )))
	(set! *resolver* (woo-get-option (car data) 'resolver))
	(set! *access* (woo-get-option (car data) 'access))
	(set! *ldap* (woo-get-option (car data) 'ldap))
	(set! *kdc* (woo-get-option (car data) 'kdc))
	(set! *smb* (woo-get-option (car data) 'smb))
	(set! *dhcpd* (woo-get-option (car data) 'dhcpd))
	(set! *master* (woo-get-option (car data) 'master))
	(set! *ad-dns* (woo-get-option (car data) 'ad_dns))
	(set! *ad-service* (woo-get-option (car data) 'ad_service))
	(set! *ad-domain* (woo-get-option (car data) 'ad_domain))
	(set! *ad-realm* (woo-get-option (car data) 'ad_realm))
	(set! *ad-dc-name* (woo-get-option (car data) 'ad_dc_name))
	(set! *ad-ldap-server* (woo-get-option (car data) 'ad_ldap_server))
	(set! *ad-kdc-server* (woo-get-option (car data) 'ad_kdc_server))
	(set! *altdomain-avail* (woo-get-option (car data) 'altdomain_is_available))
	(set! *ad-avail* (woo-get-option (car data) 'ad_is_available))
	(set! *domain-type* (woo-get-option (car data) 'domain_type))
	)
      (form-update-value "resolver" *resolver*)
      (form-update-value "access" *access*)
      (form-update-value "ldap" *ldap*)
      (form-update-value "kdc" *kdc*)
      (form-update-value "smb" *smb*)
      (form-update-value "dhcpd" *dhcpd*)
      ; Active Directory options
      (form-update-value "ad_dns" *ad-dns*)
      (form-update-value "ad_password" "")
      (form-update-value "ad_password2" "")
      ; Active Directory status
      (form-update-value "ad_service" *ad-service*)
      (form-update-value "ad_domain" *ad-domain*)
      (form-update-value "ad_realm" *ad-realm*)
      (form-update-value "ad_dc_name" *ad-dc-name*)
      (form-update-value "ad_ldap_server" *ad-ldap-server*)
      (form-update-value "ad_kdc_server" *ad-kdc-server*)
      ; Set current domain type
      (form-update-value "domain_type" *domain-type*)
      (ui-set-type)
      ; Check domain types availability
      (form-update-visibility "altdomain_available" *altdomain-avail*)
      (form-update-visibility "altdomain_unavailable"(not *altdomain-avail*))
      (form-update-visibility "altdomain_unavailable_reason" (not *altdomain-avail*))
      (form-update-visibility "ad_available" *ad-avail*)
      (form-update-visibility "ad_unavailable" (not *ad-avail*))
      (form-update-visibility "ad_unavailable_reason" (not *ad-avail*))
      )))

(define (ui-write)
  (let ((domain_type (form-value "domain_type"))
	(domain (form-value "domain")))
  (catch/message
  (lambda()
    (woo-write  "/net-domain"
		'language (form-value "language")
		'domain_type (form-value "domain_type")
		'domain (form-value "domain")
		'ad_dns (form-value "ad_dns")
		'ad_password (form-value "ad_password")
		'ad_password2 (form-value "ad_password2"))
    (ui-read)))))

; show status pane on type change
(define (ui-set-type)
  (effect-show "altdomain-status" "domain_type" "altdomain")
  (effect-show "ad-status" "domain_type" "ad")
  (update-effect))

(define (on-load)
  (ui-read)
  (init-effect)
  (form-update-activity "altdomain_unavailable" #f)
  (form-update-activity "ad_unavailable" #f)
  (form-bind "domain_type" "change" ui-set-type)
  (form-bind "submit" "click" ui-write)
  (form-bind "reset" "click" ui-read))

